/***************************************************************************
    file	         : code.h
    copyright            : (C) 1999,2000,2001,2002,2003 by Mike Richardson
			   (C) 2000,2001,2002,2003 by theKompany.com
			   (C) 2001,2002,2003 by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#define	C_OPER	0		/* Operator				*/
#define	C_BRA	1		/* Branch unconditionally		*/
#define	C_BRAT	2		/* Branch if true			*/
#define	C_BRAF	3		/* Branch if false			*/

#define	C_LOUT	5		/* Load outer variable			*/
#define	C_SOUT	6		/* Store outer variable			*/
#define	C_LBLK	7		/* Load block variable			*/
#define	C_SBLK	8		/* Store outer variable			*/
#define	C_LNUM	9		/* Load number				*/
#define	C_LSTR	10		/* Load string				*/
#define	C_POP	11		/* Pop stack				*/
#define	C_CALL	12		/* Call function			*/
#define	C_RET	13		/* Return from function			*/
#define	C_ARGC	14		/* Check number of arguments		*/
#define	C_BLKS	15		/* Set block size			*/
#define	C_SIND	16		/* Store value indirect			*/
#define	C_LIND	17		/* Load value indirect			*/
#define	C_DUP	18		/* Duplicate stack top			*/
#define	C_SWAP	19		/* Swap stack top			*/
#define	C_CALLV	20		/* Call and void result			*/
#define	C_SOUTP	21		/* Store outer variable and pop stack	*/
#define	C_SBLKP	22		/* Store block variable and pop stack	*/
#define	C_METH	23		/* Method invocation			*/
#define	C_RETN	24		/* Return a number			*/
#define	C_INCR	25		/* Increment top of stack		*/
#define	C_DECR	26		/* Decrement top of stack		*/
//
//
//
//
#define	C_AT	31		/* Code position marker			*/
#define	C_LDBL	32		/* Load double				*/
#define	C_RETD	33		/* Return a double			*/
//
//

				/* The rest are not executed ...       !*/
#define	C_PDEF	65		/* Public function definition follows  !*/
#define	C_NOUT	66		/* Number of outer names	       !*/
#define	C_NSTR	67		/* Number of strings		       !*/
#define	C_FDEF	68		/* Function definition follows	       !*/
#define	C_NDEF	69		/* Name or string definition follows   !*/
#define	C_LEN	70		/* Length specifier		       !*/

#define	OPBITS	0xff000000	/* Opcode in upper 8 bits		*/
#define	ARBITS	0x00ffffff	/* Argument in lower 24 bits		*/
#define	OPSHIFT	24		/* Shift for opcode			*/
#define	MSIZE	0x00010000	/* Master table size			*/

#define	MAGIC	0xe0e1e2e3L	/* Magic code for .elc files		*/
