/***************************************************************************
    file	         : kb_qtreplink.h
    copyright            : (C) 1999,2000,2001,2002,2003 by Mike Richardson
			   (C) 2000,2001,2002,2003 by theKompany.com
			   (C) 2001,2002,2003 by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	_KB_QTREPLINK_H
#define	_KB_QTREPLINK_H


#include	<qstrlist.h>

#include	"libkbase_exports.h"

#include	"kb_classes.h"
#include	"kb_ctrl.h"
#include	"tk_lineedit.h"


/*  KBCtrlRepLink							*/
/*  -------------							*/
/*  This class is used for link controls in reports, where what we	*/
/*  actually want is a line edit.					*/

class	LIBKBASE_API	KBCtrlRepLink : public TKLineEdit, public KBControl
{
	KBLink		*link	;
	QStrList	*valset	;

protected :

        virtual void    giveFocus	() ;

public	:

	KBCtrlRepLink (KBDisplay *, KBLink *, uint) ;
virtual~KBCtrlRepLink () ;

	virtual	void	showName	() ;
	virtual	void	setData		(void *) ;
	virtual	void	showAs		(KB::ShowAs)	  ;
	virtual	void	setValue   	(const KBValue &) ;
	virtual	KBValue	getValue   	() ;
	virtual	void	clearValue	(bool  ) ;
	virtual	bool	isEmpty		() ;
	virtual	bool	write		(KBWriter *, QRect, const KBValue &, bool, int &) ;

	SETFOCUS
	SIZEHINT
}	;

#endif	// _KB_QTREPLINK_H
