/***************************************************************************
    file	         : kb_qtrowmark.h
    copyright            : (C) 1999,2000,2001,2002,2003 by Mike Richardson
			   (C) 2000,2001,2002,2003 by theKompany.com
			   (C) 2001,2002,2003 by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	_KB_QTROWMARK_H
#define	_KB_QTROWMARK_H

#include	<qlabel.h>

#include	"kb_classes.h"
#include	"kb_ctrl.h"

#include	"libkbase_exports.h"

/*  KBCtrlRowMark							*/
/*  -------------							*/
/*  Wrapper class for row mark widgets					*/

class LIBKBASE_API	KBCtrlRowMark : public QLabel, public KBControl
{
	KBRowMark	*m_rowmark	;
	bool		m_current	;
	bool		m_inBlock	;
	KB::RState	m_state		;
	bool		m_showRow	;
	uint		m_rowNo		;

	void		showIcon	() ;

protected :

        virtual void    giveFocus     	() ;
	virtual	bool	eventFilter	(QObject *, QEvent *)	;

public	:

	KBCtrlRowMark (KBDisplay *, KBRowMark *, uint) ;
virtual~KBCtrlRowMark () ;

	virtual	void	redraw		() ;
	virtual	void	setData		(void *) ;
	virtual	void	clearValue	(bool  ) ;
	virtual	void	showAs		(KB::ShowAs) ;
	virtual	bool	write		(KBWriter *, QRect, const KBValue &, bool, int &) ;

	SETFOCUS
	SIZEHINT
}	;

#endif	// _KB_QTROWMARK_H
