/***************************************************************************
    file	         : kb_recordnav.h
    copyright            : (C) 1999,2000,2001,2002,2003 by Mike Richardson
			   (C) 2000,2001,2002,2003 by theKompany.com
			   (C) 2001,2002,2003 by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__KB_RECORDNAV_H
#define	__KB_RECORDNAV_H


#include	<qframe.h>
#include	<qpushbutton.h>
#include	<qlabel.h>

#include	"kb_classes.h"
#include 	"libkbase_exports.h"


/*  KBRecordNav								*/
/*  -----------								*/
/*  This class provides a record navigation and record number tool for	*/
/*  use in blocks and elsewhere.					*/

class	LIBKBASE_API KBRecordNav : public QFrame
{
	Q_OBJECT

	QPushButton	m_bFirst	;
	QPushButton	m_bPrevious	;
	QLabel		m_lRecordNo	;
	QPushButton	m_bNext		;
	QPushButton	m_bLast		;
	QPushButton	m_bAdd		;

signals :

	void		action	(KB::Action)	;

protected slots :

	void		slotClickFirst		() ;
	void		slotClickPrevious	() ;
	void		slotClickNext		() ;
	void		slotClickLast		() ;
	void		slotClickAdd		() ;

public	:

	KBRecordNav	(QWidget *, uint)	;

	void		setRecord	(uint, uint) ;
}	;

#endif	// __KB_RECORDNAV_H
