/***************************************************************************
    file	         : tk_filedialog.h
    copyright            : (C) 1999,2000,2001,2002,2003 by Mike Richardson
			   (C) 2000,2001,2002,2003 by theKompany.com
			   (C) 2001,2002,2003 by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__TK_FILEDIALOG_H
#define	__TK_FILEDIALOG_H

#include	<qfiledialog.h>

#include "libtkkde_exports.h"

class LIBTKKDE_API KBFileDialog : public QFileDialog
{
public	:

	static	QString	getOpenFileName
		(	const QString	&startDir	= QString::null,
			const QString	&filter		= QString::null,
			QWidget		*parent		= 0,
			const QString	&caption	= QString::null
		)	;

	static	QString	getSaveFileName
		(	const QString	&startDir	= QString::null,
			const QString	&filter		= QString::null,
			QWidget		*parent		= 0,
			const QString	&caption	= QString::null
		)	;

	static	QString	getExistingDirectory
		(	const QString	&startDir	= QString::null,
			const QString	&caption	= QString::null
		)	;

	KBFileDialog
		(	const QString	&startDir,
			const QString	&filter,
			QWidget		*parent,
			const char	*name,
			bool		modal
		)	;

	QString	currentFilter ()	;

	enum	KBMode
	{
		Directory,
		ExistingFile,
		AnyFile,
		ExistingFiles
	}	;

	void	setMode	      (KBFileDialog::KBMode) ;
}	;

#endif	// __TK_FILEDIALOG_H
