/***************************************************************************
    file	         : kb_componentlist.cpp
    copyright            : (C) 1999,2000,2001,2002,2003 by Mike Richardson
			   (C) 2000,2001,2002,2003 by theKompany.com
			   (C) 2001,2002,2003 by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#include	<qcursor.h>
#include	<qpopupmenu.h>

#include	"kb_classes.h"
#include	"kb_location.h"
#include	"kb_dbinfo.h"
#include	"kb_listitem.h"
#include	"kb_viewer.h"
#include	"kb_callback.h"
#include	"kb_appptr.h"

#ifndef 	_WIN32
#include	"kb_componentlist.moc"
#else
#include 	"kb_componentlist.h"
#endif



/*  KBComponentList							*/
/*  KBComponentList							*/
/*		: Constructor for component list widget			*/
/*  parent	: QWidget *	  : Parent widget			*/
/*  dbInfo	: KBDBInfo *	  : Database information object		*/
/*  (returns)	: KBComponentList	  :					*/

KBComponentList::KBComponentList
	(	QWidget		*parent,
		KBDBInfo	*dbInfo
	)
	:
	KBFileList
	(	parent,
		dbInfo,
		"Create new component",
		"component",
		"component",
		"Component name"
	)
{
}

/*  KBComponentList							*/
/*  ~KBComponentList							*/
/*		: Destructor for component list widget			*/
/*  (returns)	:		:					*/

KBComponentList::~KBComponentList ()
{
}

/*  KBComponentList							*/
/*  showServerMenu : Show popup menu for server entries			*/
/*  (returns)	   : void	:					*/

void	KBComponentList::showServerMenu ()
{
	QPopupMenu pop ;
	pop.insertItem (TR("Cancel")) ;
	pop.insertSeparator () ;
	pop.insertItem (TR("&Reload component list"), this, SLOT(reloadServer())) ;
	pop.insertItem (TR("&Copy to server ..."),    this, SLOT(copyToServer())) ;
	pop.exec       (QCursor::pos()) ;
}

/*  KBComponentList							*/
/*  showObjectMenu : Show popup menu for server entries			*/
/*  (returns)	   : void	:					*/

void	KBComponentList::showObjectMenu ()
{
	QPopupMenu pop ;
	pop.insertItem (TR("Cancel")) ;
	pop.insertItem (TR("&Edit component"),   this, SLOT(showAsData	   ())) ;
	pop.insertItem (TR("&Rename component"), this, SLOT(renameComponent())) ;
	pop.insertItem (TR("De&lete component"), this, SLOT(deleteComponent())) ;
	pop.insertItem (TR("&Save to file"),     this, SLOT(saveToFile     ())) ;
	pop.exec       (QCursor::pos()) ;
}

/*  KBComponentList							*/
/*  renameComponent							*/
/*		: Rename a component					*/
/*  (returns)	: void		:					*/

void	KBComponentList::renameComponent ()
{
	rename	(m_curItem) ;
}

/*  KBComponentList							*/
/*  deleteComponment							*/
/*		: Delete a component					*/
/*  (returns)	: void		:					*/

void	KBComponentList::deleteComponent ()
{
	delobj	(m_curItem) ;
}
