/***************************************************************************
    file	         : kb_conductor.h
    copyright            : (C) 1999,2000,2001,2002,2003 by Mike Richardson
			   (C) 2000,2001,2002,2003 by theKompany.com
			   (C) 2001,2002,2003 by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__KB_CONDUCTOR_H
#define	__KB_CONDUCTOR_H

#include	<qwidget.h>
#include	<qdialog.h>
#include	<qpushbutton.h>
#include	<qcombobox.h>
#include	<qtextbrowser.h>
#include	<qlabel.h>
#include	<qlayout.h>
#include	<qsocket.h>


#include	"kb_classes.h"



struct	MsgBuff
{
	uint	len	;
	uint	seq	;
	uint	code	;
	char	buff[1]	;
}	;

class	KBConductorDlg : public QDialog
{
	Q_OBJECT

	QTextBrowser	m_browser	;
	QLabel		m_lSeq		;
	QComboBox	m_cMode		;
	QPushButton	m_bContinue	;
	QPushButton	m_bCancel	;

	QVBoxLayout	*m_layMain	;
	QHBoxLayout	*m_layButtons	;

	QSocket		m_socket	;

	bool		m_pause		;
	uint		m_len		;
	uint		m_got		;
	MsgBuff		*m_msg		;

protected slots :

	void		changeMode	()	;
	void		clickContinue	()	;
	void		clickCancel	()	;
	void		slotReadyRead	()	;
	void		slotLinkClosed	()	;

public	:

	KBConductorDlg 		() 	;
	virtual	~KBConductorDlg () 	;
}	;

#endif
